lemonade
=========
[![Build Status](https://travis-ci.org/runlevel3/lemonade.png)](https://travis-ci.org/runlevel3/lemonade)
[![NPM version](https://badge.fury.io/js/lemonade.png)](http://badge.fury.io/js/lemonade)
<!--[![Dependency Status](https://gemnasium.com/runlevel3/lemonade.png)](https://gemnasium.com/runlevel3/lemonade)-->

Jump to [documentation](https://github.com/runlevel3/lemonade/wiki/)

## api framework
Lemonade is a nodejs framework designed to be used for backend apis. Emphasis is put on software adaptors, logging and communication via a serialized (jsoned) objects.

## abstract wrappers
Access to different software is essential when building a backend api. Lemonade tries to provide access to multiple software using abstract wrappers. No hassle about choosing an adaptor or refactoring parts of your application once an adaptor changes.

Adaptors built into lemonade : [mysql](https://github.com/runlevel3/lemonade/wiki/mysql), [cassandra](https://github.com/runlevel3/lemonade/wiki/cassandra), [rabbitmq](https://github.com/runlevel3/lemonade/wiki/rabbitmq), [solr](https://github.com/runlevel3/lemonade/wiki/solr)

Custom adaptors can be easily built or existing ones overloaded : [creating and overloading links](https://github.com/runlevel3/lemonade/wiki/links)

## built in daemons
Lemonade comes with built in [http daemon](https://github.com/runlevel3/lemonade/wiki/httpd) and [spinner daemon](https://github.com/runlevel3/lemonade/wiki/spinner) (crontab).

## mvc structure
Application logic is structured on the mvc model. Http requests get routed to [controllers](https://github.com/runlevel3/lemonade/wiki/application-structure) and crontabs spawn [intervals](https://github.com/runlevel3/lemonade/wiki/application-structure). [Models](https://github.com/runlevel3/lemonade/wiki/application-structure) and [views](https://github.com/runlevel3/lemonade/wiki/application-structure) are available as well.

## graceful shutdown and restart
All daemons and adaptors are built with unload methods, so a graceful application shutdown and restart can be initiated at any time (sigterms can be used).

## source file supervising
Lemonade can be started using the --watch-changes option. This will launch a watcher on the application directory which will gracefully restart the app once the sources change.

## standardized object structure and inclusion
All objects are overloaded when created with references to the main object (kernel) and to the instance object (if present). Objects can be created as singletons.                            
                            
## template engines
Depending on the extension a different template engine will be used. See [more about templates](https://github.com/runlevel3/lemonade/wiki/templates)

## documentation
[documentation](https://github.com/runlevel3/lemonade/wiki/)

## how to contribute
Use any of github's tools for contributing or contact us at contact@lemonadejs.com for any thoughts, suggestions, ideas or criticism (we welcome any input!).

## license (MIT)

    
    Copyright (C) 2012-2013 http://lemonadejs.com https://github.com/runlevel3 

    Permission is hereby granted, free of charge, to any person obtaining a copy of this software and 
    associated documentation files (the "Software"), to deal in the Software without restriction, 
    including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense,
    and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so,
    subject to the following conditions:

    The above copyright notice and this permission notice shall be included in all copies or substantial 
    portions of the Software.

    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT
    LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
    IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
    LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
    WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

