/**
 * Lemonade JS
 * https://lemonadejs.com
 *
 * ----
 *
 * config.js
 */
exports = module.exports = {
    /**
     * Configuration constants
     */
    config : {
        project : 'Lemonade demo project'
        , logpath : '../logs/' // keep logpath outside of the appdir
    }
    /**
     * Boot modules
     */
    ,boot : {
        /**
         * Dummy link, check appdir/links/dummy.js
         * for more info
         */
        dum : 'dummy'
        /**
         * Mysql configuration with master / slave
         */
        /*, db : [
            'mysql'
            , { host : '', user : '', pass : '', port : '' } //master
            , { host : '', user : '', pass : '', port : '' } //slave
            , '' //defaultdb
            ,  { slow : 5 } //log queries that take longer
        ]*/
        /**
         * cassandra configuration
         */
        /*, storage : [
            'cassandra'
            , [ { host : '', port : '' } , { host : '', port : '' } ] //hosts
            , '' //default keyspace
            , { user : '', pass : '', slow : 5 } //options
        ]*/
        /**
         * rabbitMq configuration
         */
        /*, queue : [ 'rabbit' , { host : '' , port : '' } ]*/
        /**
         * solr configuration
         */
        /*, search : [
            'solr'
            , { host : '', port : '' } //master
            , { host : '', port : '' } //slave
            , '' //defaultcore
            , { slow : 5 } //log queries that take longer
        ]*/
    }
    /**
     * Run modules
     */
    ,run : {
        /**
         * Start the httpd server on the specified port
         */
        webserver : [ 'httpd', 2037 ]
        /**
         * Spin some crontabs
         */
        , crontab : 'spinner'
    }
    /**
     * Methods to run on lemonade exit
     */
    ,shutdown : { }
};