/******************************************************************************
 * Lemonade JS
 * https://lemonadejs.com
 *
 * ----
 *
 * Include
 *
 *  Load the appropriate includer based on path's content-type (extension for
 *  now)
 *
 * @param {string} path
 * @param {object} context
 * @param {object} kernel
 *
 *****************************************************************************/

function Include(path, context, kernel) {
    var extension = path.substring(
        path.lastIndexOf('.') + 1, path.length
    );
    try {
        switch (extension) {
            case 'swig' :
            case 'swg'  :
                var includer = require('./include/swig.js');
                break;
            default :
                var includer = require('./include/js.js');
                break;
        }
    } catch (e) {
        this.kernel.error(
            new Error(
                'Failed to load content-type not supported : ' + extension + ' : ' + e.message
            )
        );
    }
    return new includer(path, context, kernel);
}

/**
 * Exports
 */
exports = module.exports = Include;