/******************************************************************************
 * Lemonade JS
 * https://lemonadejs.com
 *
 * ----
 *
 * IncludeSwig
 *
 *  Return a compiled swig template, ready for parsing
 *
 * @param {string} path
 *
 *****************************************************************************/

function IncludeSwig(path) {
    this.tpl = swig.compileFile(path);
    return function(vars) {
        return this.tpl.render(vars);
    }.bind(this)
}

IncludeSwig.prototype.tpl = '';

/**
 * Dependencies
 */
var swig = require('swig');

/**
 * Exports
 */
exports = module.exports = IncludeSwig;