/******************************************************************************
 * Lemonade JS
 * https://lemonadejs.com
 *
 * ----
 *
 * InstanceView
 *
 *  Parse a template and replace placeholders with corresponding variables.
 *
 *****************************************************************************/

function InstanceView() {}

/**
 * Template body
 * @type {object}
 */
InstanceView.prototype.tpl;

/**
 * Template body after parsing
 * @type {string}
 */
InstanceView.prototype.parsed = '';

/**
 * Load the template body
 * @param path
 */
InstanceView.prototype.load = function(path) {
    this.tpl = this.kernel.include(path);
    return this.tpl;
};

/**
 * Parse the template body
 * @param {object} vars
 */
InstanceView.prototype.parse = function(vars) {
    this.parsed = this.tpl(vars);
    return this.parsed;
};

/**
 * Exports
 */
exports = module.exports = InstanceView;